summaryrefslogtreecommitdiff
path: root/agen5/test/stack.test
diff options
context:
space:
mode:
Diffstat (limited to 'agen5/test/stack.test')
-rwxr-xr-xagen5/test/stack.test93
1 files changed, 93 insertions, 0 deletions
diff --git a/agen5/test/stack.test b/agen5/test/stack.test
new file mode 100755
index 0000000..32317af
--- /dev/null
+++ b/agen5/test/stack.test
@@ -0,0 +1,93 @@
+#! /bin/sh
+# -*- Mode: Shell-script -*-
+# ----------------------------------------------------------------------
+# stack.test --- test stack and join functionality
+#
+## Time-stamp: "2010-02-24 08:41:38 bkorb"
+# Author: Bruce Korb <bkorb@gnu.org>
+##
+## This file is part of AutoGen.
+## AutoGen Copyright (c) 1992-2012 by Bruce Korb - all rights reserved
+##
+## AutoGen is free software: you can redistribute it and/or modify it
+## under the terms of the GNU General Public License as published by the
+## Free Software Foundation, either version 3 of the License, or
+## (at your option) any later version.
+##
+## AutoGen is distributed in the hope that it will be useful, but
+## WITHOUT ANY WARRANTY; without even the implied warranty of
+## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
+## See the GNU General Public License for more details.
+##
+## You should have received a copy of the GNU General Public License along
+## with this program. If not, see <http://www.gnu.org/licenses/>.
+##
+# ----------------------------------------------------------------------
+
+. ./defs
+
+# # # # # # # # # # TEMPLATE FILE # # # # # # # # #
+
+echo creating ${testname}.tpl
+cat > ${testname}.tpl <<_EOF_
+[= AutoGen5 template test =]
+[=
+
+ (join ", " (stack "foo.bar.baz"))
+
+=]
+[=
+
+ (join ",\n" "one" "two" "three" "four" )
+
+=]
+[=
+
+ (join ", " "foo" (stack "foo.bar.baz") "bar" "baz")
+
+=]
+[= (string-substitute (join "\n" (stack "foo.bar.baz"))
+ '("umb" "le") '("_UMB_" "<=") ) =]
+_EOF_
+
+# # # # # # # # # # DEFINITIONS FILE # # # # # # # # #
+
+echo creating ${testname}.def
+cat > ${testname}.def <<_EOF_
+AutoGen definitions ${testname};
+
+foo = { bar = { baz = fumble; }; };
+foo = { bar = { baz = mumble; }; };
+foo = { bar = { baz = grumble; }; };
+_EOF_
+
+# # # # # # # # # # EXPECTED OUTPUT FILE # # # # # # #
+set -x
+echo creating ${testname}.out
+# this is the output we should expect to see
+cat > ${testname}.out <<'_EOF_'
+fumble, mumble, grumble
+one,
+two,
+three,
+four
+foo, fumble, mumble, grumble, bar, baz
+f_UMB_<=
+m_UMB_<=
+gr_UMB_<=
+_EOF_
+
+run_ag x ${testname}.def || failure autogen failed
+cmp -s ${testname}.test ${testname}.out || \
+ failure "`diff ${testname}.*t`"
+
+cleanup
+
+## Local Variables:
+## mode: shell-script
+## indent-tabs-mode: nil
+## sh-indentation: 2
+## sh-basic-offset: 2
+## End:
+
+# end of stack.test